#include "SDL.h"
#define N_ALIENS	7
#define BUF_ALIEN	30
#define BUF_EXPLOSION	30
#define SPRITE_SIZE	40
#define BUL_H		20
#define BUL_W		10

typedef struct {
	SDL_Surface *img;
	SDL_Rect    pos;
	int x;
	int y;
	Uint8 w;
	Uint8 h;
	Sint8 V_dir;
	Sint8 H_dir;
	Uint8 is_moving;   // unused
	Uint8 weapon; // unused
} Darkship;

typedef struct {
	SDL_Surface *img;
	SDL_Rect pos;
	int type;     // unused
	int scheme;   // unused
	int destroyed;
	int V_dir;
	int H_dir;
	int x;
	int y;
	int w;
	int h;
	int points;
} Enemy;

typedef struct {
	SDL_Rect pos;
	Uint32 color;
	int x;
	int y;
} Star;

typedef struct {
	SDL_Surface  *img;
	SDL_Rect pos;
	int x;
	int y;
	Uint8 w;
	Uint8 h;
} Bullet;

typedef struct {
	SDL_Surface *img;
	SDL_Rect pos;
	int x;
	int y;
	Uint8 ttl;
} Explosion;

typedef struct {
	SDL_Surface *img;
	SDL_Rect pos;
	int x;
	int y;
	Uint8 frame;
} Meteor;

struct map_ship_a {
	Uint8 map_a[SPRITE_SIZE*SPRITE_SIZE];
	Uint8 map_b[SPRITE_SIZE*SPRITE_SIZE];
	Uint8 map_c[SPRITE_SIZE*SPRITE_SIZE];
};

struct map_alien_a {
	Uint8 map_l[SPRITE_SIZE*SPRITE_SIZE];
	Uint8 map_r[SPRITE_SIZE*SPRITE_SIZE];
	Uint8 map_u[SPRITE_SIZE*SPRITE_SIZE];
	Uint8 map_d[SPRITE_SIZE*SPRITE_SIZE];
	Uint8 map_lu[SPRITE_SIZE*SPRITE_SIZE];
	Uint8 map_ru[SPRITE_SIZE*SPRITE_SIZE];
	Uint8 map_ld[SPRITE_SIZE*SPRITE_SIZE];
	Uint8 map_rd[SPRITE_SIZE*SPRITE_SIZE];
};

struct map_bul {
	Uint8 A[BUL_H * BUL_W];
};

extern struct map_alien_a map_ala;
extern struct map_ship_a  map_shipa;
extern struct map_bul     map_bulA;

extern Darkship  darkship;
extern Enemy	 alien[BUF_ALIEN];
extern Explosion explosion[BUF_EXPLOSION];
extern Meteor    meteor;
