#include "SDL.h"
#include "darkbattle.h"

SDL_Surface *screen;
SDL_Surface *ship_img_a;
SDL_Surface *ship_img_b;
SDL_Surface *ship_img_c;
SDL_Surface *al_img;
SDL_Surface *ar_img;
SDL_Surface *ad_img;
SDL_Surface *au_img;
SDL_Surface *ald_img;
SDL_Surface *ard_img;
SDL_Surface *alu_img;
SDL_Surface *aru_img;
SDL_Surface *bullet_0_img;
SDL_Surface *open_1;
SDL_Surface *expl1_img, *expl2_img, *expl3_img;
SDL_Surface *met_a1, *met_a2, *met_a3, *met_a4, *met_a5;

struct map_alien_a map_ala;
struct map_ship_a map_shipa;
struct map_bul map_bullA;

Uint8 r;
Uint8 g;
Uint8 b;

// return -1 if errors
int load_images(void) {
	ship_img_a = (SDL_Surface *)IMG_Load("Images/ship_v.png");
	ship_img_b = (SDL_Surface *)IMG_Load("Images/ship_l.png");
	ship_img_c = (SDL_Surface *)IMG_Load("Images/ship_r.png");
	al_img = (SDL_Surface *)IMG_Load("Images/bl.png");
	ar_img = (SDL_Surface *)IMG_Load("Images/br.png");
	au_img = (SDL_Surface *)IMG_Load("Images/bu.png");
	ad_img = (SDL_Surface *)IMG_Load("Images/bd.png");
	alu_img = (SDL_Surface *)IMG_Load("Images/blu.png");
	ard_img = (SDL_Surface *)IMG_Load("Images/brd.png");
	aru_img = (SDL_Surface *)IMG_Load("Images/bru.png");
	ald_img = (SDL_Surface *)IMG_Load("Images/bld.png");
	expl1_img = (SDL_Surface *)IMG_Load("Images/expl_1.png");
	expl2_img = (SDL_Surface *)IMG_Load("Images/expl_2.png");
	expl3_img = (SDL_Surface *)IMG_Load("Images/expl_3.png");
	open_1 = (SDL_Surface *)IMG_Load("Images/open_1.png");
	bullet_0_img = (SDL_Surface *)IMG_Load("Images/bullet_b.png");
	met_a1 = (SDL_Surface *)IMG_Load("Images/meteor_a1.png");
	met_a2 = (SDL_Surface *)IMG_Load("Images/meteor_a2.png");
	met_a3 = (SDL_Surface *)IMG_Load("Images/meteor_a3.png");
	met_a4 = (SDL_Surface *)IMG_Load("Images/meteor_a4.png");
	met_a5 = (SDL_Surface *)IMG_Load("Images/meteor_a5.png");
	if(ship_img_a == NULL)
		return -1;
	if(ship_img_a == NULL)
		return -1;
	if(ship_img_b == NULL)
		return -1;
	if(ship_img_c == NULL)
		return -1;
	if(al_img == NULL)
		return -1;
	if(ar_img == NULL)
		return -1;
	if(ald_img == NULL)
		return -1;
	if(ard_img == NULL)
		return -1;
	if(alu_img == NULL)
		return -1;
	if(aru_img == NULL)
		return -1;
	if(expl1_img == NULL)
		return -1;
	if(expl2_img == NULL)
		return -1;
	if(expl3_img == NULL)
		return -1;
	if(open_1 == NULL)
		return -1;
	if(met_a1 == NULL)
		return -1;
	if(met_a2 == NULL)
		return -1;
	if(met_a3 == NULL)
		return -1;
	if(met_a4 == NULL)
		return -1;
	if(met_a5 == NULL)
		return -1;

	SDL_SetColorKey(ship_img_a, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(ship_img_b, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(ship_img_c, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(al_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(ar_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(ad_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(au_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(alu_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(aru_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(ald_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(ard_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(expl1_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(expl2_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(expl3_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(met_a1, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(met_a2, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(met_a3, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(met_a4, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(met_a5, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	SDL_SetColorKey(bullet_0_img, SDL_SRCCOLORKEY,
					SDL_MapRGB(screen->format, 0, 0, 0));
	return 0;
}

Uint8 map_pixel(SDL_Surface *img, int x, int y) {
	Uint8 *p;
	Uint8 i, j, bpp;
	SDL_PixelFormat *fmt;
	bpp = img->format->BytesPerPixel;

	(Uint8 *)p = (Uint8 *)img->pixels + y * img->pitch + x * bpp;
	switch(bpp) {
		case 1:
			SDL_GetRGB(*p, img->format, &r, &g, &b);
			if(r == 0 && g == 0 && b == 0)
				return 0;
			else
				return 1;
		case 2:
			SDL_GetRGB(*(Uint16 *)p, img->format, &r, &g, &b);
			if(r == 0 && g == 0 && b == 0)
				return 0;
			else
				return 1;
		case 3:
			if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
				*p = p[0] << 16 | p[1] << 8 | p[2];
			else
				*p = p[0] | p[1] << 8 | p[2] << 16;
			SDL_GetRGB(*p, img->format, &r, &g, &b);
			if(r == 0 && g == 0 && b == 0)
				return 0;
			else
				return 1;
		case 4:
			SDL_GetRGB(*(Uint32 *)p, img->format, &r, &g, &b);
			if(r == 0 && g == 0 && b == 0)
				return 0;
			else
				return 1;
		default:
			break;
	}
}

void map_bullets(void) {
	Uint8 i, j;

	for(i=0; i<BUL_H; i++) {
		for(j=0; j<BUL_W; j++) {
			map_bulA.A[i*j+i] = map_pixel(bullet_0_img, j, i);
		}
	}
}

void map_aliens(void) {
	Uint8 i, j;

	for(i=0; i<SPRITE_SIZE; i++) {
		for(j=0; j<SPRITE_SIZE; j++) {
			map_ala.map_l[i*j+i] = map_pixel(al_img, j, i);
			map_ala.map_r[i*j+i] = map_pixel(ar_img, j, i);
			map_ala.map_u[i*j+i] = map_pixel(au_img, j, i);
			map_ala.map_d[i*j+i] = map_pixel(ad_img, j, i);
			map_ala.map_lu[i*j+i] = map_pixel(alu_img, j, i);
			map_ala.map_ld[i*j+i] = map_pixel(ald_img, j, i);
			map_ala.map_rd[i*j+i] = map_pixel(aru_img, j, i);
			map_ala.map_ru[i*j+i] = map_pixel(ard_img, j, i);
		}
	}
}

void map_ships(void) {
	Uint8 i, j;

	for(i=0; i<SPRITE_SIZE; i++) {
		for(j=0; j<SPRITE_SIZE; j++) {
			map_shipa.map_a[i*j+i] = map_pixel(al_img, j, i);
			map_shipa.map_b[i*j+i] = map_pixel(al_img, j, i);
			map_shipa.map_c[i*j+i] = map_pixel(al_img, j, i);
		}
	}
}
void unload_images(void) {
	SDL_FreeSurface(ship_img_a);
	SDL_FreeSurface(ship_img_b);
	SDL_FreeSurface(ship_img_c);
	SDL_FreeSurface(al_img);
	SDL_FreeSurface(ar_img);
	SDL_FreeSurface(ad_img);
	SDL_FreeSurface(au_img);
	SDL_FreeSurface(ald_img);
	SDL_FreeSurface(ard_img);
	SDL_FreeSurface(alu_img);
	SDL_FreeSurface(aru_img);
	SDL_FreeSurface(expl1_img);
	SDL_FreeSurface(expl2_img);
	SDL_FreeSurface(expl3_img);
	SDL_FreeSurface(open_1);
	SDL_FreeSurface(bullet_0_img);
}
