#include "SDL.h"
#include "darkbattle.h"

#define SPEED_EN  	10   // speed of enemies
#define GAP_1		75   // gap between aliens in scheme 1
#define SCHEME_1_Y	50


SDL_Surface *screen;
SDL_Surface *al_img;
SDL_Surface *ar_img;
SDL_Surface *ad_img;
SDL_Surface *au_img;
SDL_Surface *ald_img;
SDL_Surface *ard_img;
SDL_Surface *alu_img;
SDL_Surface *aru_img;

Uint8 alien_type;
Uint8 nAlien;

Enemy alien[BUF_ALIEN];

void give_alien_img(Enemy *alien) {
	if(alien->H_dir == 0 && alien->V_dir == -1)
		alien->img = ad_img;
	if(alien->H_dir == 0 && alien->V_dir == 1)
		alien->img = au_img;
	if(alien->H_dir == -1 && alien->V_dir == -1)
		alien->img = ald_img;
	if(alien->H_dir == -1 && alien->V_dir == 1)
		alien->img = alu_img;
	if(alien->H_dir == -1 && alien->V_dir == 0)
		alien->img = al_img;
	if(alien->H_dir == 1 && alien->V_dir == 0)
		alien->img = ar_img;
	if(alien->H_dir == 1 && alien->V_dir == -1)
		alien->img = ard_img;
	if(alien->H_dir == 1 && alien->V_dir == 1)
		alien->img = aru_img;
}


void init_scheme(int scheme) {
	Uint8 i, a;
	if(scheme == 1) {
		i = nAlien;
		a = nAlien + N_ALIENS;
		for(i; i<a; i++) {
			alien[i].type = alien_type;
			alien[i].scheme = 1;
			alien[i].V_dir = -1;
			alien[i].H_dir = 0;
			give_alien_img(&alien[i]);
			alien[i].x = 150;
			alien[i].y = (i * (SPRITE_SIZE + GAP_1) * (-1)) - SPRITE_SIZE;
			alien[i].w = SPRITE_SIZE;
			alien[i].h = SPRITE_SIZE;
			alien[i].destroyed = 0;
			if(alien[i].type == 0)
				alien[i].points = 125;
#ifdef DEBUG
			printf("i: %d\t x: %d\n", i, alien[i].pos.x);
#endif
			nAlien++;
			if(nAlien == BUF_ALIEN)
				nAlien = 0;
		}
	}
	if(scheme == 2) {
		i = nAlien;
		a = nAlien + N_ALIENS;
		for(; i<a; i++) {
			alien[i].type = alien_type;
			alien[i].scheme = 2;
			alien[i].img = al_img;
			alien[i].x = 640 + (i * GAP_1 + SPRITE_SIZE);
			alien[i].y = SCHEME_1_Y;
			alien[i].w = SPRITE_SIZE;
			alien[i].h = SPRITE_SIZE;
			alien[i].destroyed = 0;
			if(alien[i].type == 0)
				alien[i].points = 125;
#ifdef DEBUG
			printf("i: %d\t x: %d\n", i, alien[i].pos.x);
#endif
			nAlien++;
			if(nAlien == BUF_ALIEN)
				nAlien = 0;
		}
	}
}

void calc_alien_pos(void) {
	Uint8 i;

	for(i=0; i<BUF_ALIEN; i++) {
		if(alien[i].img != NULL && alien[i].scheme == 1) {
			alien[i].y += SPEED_EN;
			if(alien[i].y > 200) {
				alien[i].x -= SPEED_EN;
				alien[i].H_dir = -1;
			}
			alien[i].pos.x = alien[i].x;
			alien[i].pos.y = alien[i].y;
			alien[i].w = SPRITE_SIZE;
			alien[i].h = SPRITE_SIZE;
			alien[i].pos.w = alien[i].w;
			alien[i].pos.h = alien[i].h;
#ifdef DEBUG
			printf("i: %d\tx: %d\ty: %d\n", i, alien[i].x, alien[i].y);
#endif
			give_alien_img(&alien[i]);
/*
			if(alien[i].pos.x > 150 || alien[i].pos.x < 0)
				alien[i].img = ar_img;
			else
				alien[i].img = ard_img;
*/
			display_img(alien[i].img, &alien[i].pos);
		}
		if(alien[i].img != NULL && alien[i].scheme == 2) {
			alien[i].x -= SPEED_EN;
			if(alien[i].x < 640 && alien[i].x > 640 - 150)
				alien[i].y += SPEED_EN;
			alien[i].pos.x = alien[i].x;
			alien[i].pos.y = alien[i].y;
			alien[i].w = SPRITE_SIZE;
			alien[i].h = SPRITE_SIZE;
			alien[i].pos.w = alien[i].w;
			alien[i].pos.h = alien[i].h;
#ifdef DEBUG
			printf("i: %d\tx: %d\ty: %d\n", i, alien[i].x, alien[i].y);
#endif
			if(alien[i].pos.x < 640 - 150 || alien[i].pos.x > 640)
				alien[i].img = al_img;
			else
				alien[i].img = ald_img;
			display_img(alien[i].img, &alien[i].pos);
		}
	}
}

void erase_old_alien(void) {
	Uint8 i;
	for(i=0; i<BUF_ALIEN; i++) {
		if(alien[i].img != NULL || alien[i].destroyed == 1)
			SDL_FillRect(screen, &alien[i].pos, SDL_MapRGB(screen->format, 0, 0, 0));
	}
}
